// ___SETA43  _____
// 19/04/2025 _____
// RADIO Si4732 FM-AM
// Arduino 1.8.19
// seta43.duckdns.org
// seta43.blogspot.com

/*
    | Si4732 pin      |  Arduino Pin  |
    | ----------------| ------------  |
    | RESET (pin 9)   |     12        |
    | SDIO (pin 12)   |     A4        |
    | CLK (pin 11)    |     A5        |
*/

/*
    | ROTARY ENCODER  | ARDUINO
    | ----------------| -----------  |
    | IZQUIERDA       |     2        |
    | DERECHA         |     3        |
    | BUTTON          |     4        |
 */

char nombre[]="SETA43 AM_SI4732";
 
#include "Rotary.h";
#define ROTARY_PIN1 3
#define ROTARY_PIN2 2
#define BUTTON_PIN  4
#define CLICKS_PER_STEP   2   // this number depends on your rotary encoder 

#define FRECUINI 8700
#define FRECUFIN 10800
#define FRECUSTART 9470
#define FRECUSTART_AM 600


Rotary r;
int rNum=10;
int rDir;
/////////////////////////////////////////////////////////////////
//___________OLED_________
#include "olex.h"
#include <Wire.h>
/////////////////////////////////////////////////////////////////
#include <SI4735.h>
#define RESET_PIN 12
SI4735 chipRadio;

uint16_t frecuencia=FRECUSTART;
/////////////////////////////////////////////////////////////////
char cadena[30];

bool Mstereo;
char Mvolumen=50;
char Mmodo=0;
char Magc=0;
char Mpasos=10;
char Mwbanda=0;
char Msnr,Mrssi;

static char *menus[]={"EXIT","Volumen","AM-FM","STEP","AGC","BandwAM","Info"};
#define NMENUS (sizeof(menus)/sizeof(menus[0]))

const char *OffOn[] = {"OFF", "ON "};
const char *MModeDesc[] = {"FM", "AM"};
char bwIdxAM = 0;
const char *bandwidthAM[] = {"6", "4", "3", "2", "1", "1.8", "2.5"};
const char *stereo[] = {"MONO", "STE "};

void setup() 
{
Serial.begin(9600);
  while (!Serial) {;}
  Serial.println(nombre);
  pinMode(RESET_PIN, OUTPUT);  
  digitalWrite(RESET_PIN, HIGH);
  delay(200);  
  Wire.begin(); // I2C bus
  scanI2C();
  OleInit(); delay(200);
  xclearDisplay();  ModeFont=0; xStringAT(0,0,(char *)nombre);
  delay(300); xclearDisplay(); 
///////////////////////////////////////////////////////////////// 
  r.begin(ROTARY_PIN1, ROTARY_PIN2, CLICKS_PER_STEP);
  r.setLeftRotationHandler(showDirection);
  r.setRightRotationHandler(showDirection);
  pinMode(ROTARY_PIN1, INPUT_PULLUP); 
  pinMode(ROTARY_PIN2, INPUT_PULLUP);
  pinMode(BUTTON_PIN, INPUT_PULLUP); 
///////////////////////////////////////////////////////////////// 
  int16_t si4735Addr = chipRadio.getDeviceI2CAddress(RESET_PIN);
  if ( si4735Addr == 0 ) {Serial.println("Si4732 not found!"); while (1) ;} 
  chipRadio.setup(RESET_PIN, 0);
  bandaUsada(Mmodo);

  chipRadio.setRdsConfig(3, 3, 3, 3, 3);
  chipRadio.setFifoCount(1);
///////////////////////////////////////////////////////////////// 
  chipRadio.setAutomaticGainControl(Magc, 1);
  chipRadio.setBandwidth(bwIdxAM, 1);
  chipRadio.setVolume(Mvolumen); //Sets volume level (0 to 63 max). 
  printDataS(); 
}

int t;
char f2,f3=1;
char modoMenu=0;
char info=1;

void loop() 
{
	  delayMicroseconds(100);
    t++;    
    if(t>5000)
        {
          if(f3==1)   
            { 
              chipRadio.setFrequency(frecuencia); 
              printFrecuOLED();                
              f3=0; t=0;
            }
        }
    if(t>10000)
        {
          t=0;
          if(info==1)
            {   
              printData();  
              Serial.print(frecuencia);
              if(Mmodo==0) 
                {Serial.print("MHz<FM");checkRds(); Serial.println("<RDS");}
                else
                { Serial.println("KHz<AM");}
            }       
        }
    
    if(1==F_boton())  { menuX();  printFrecuOLED(); printDataS(); 
    }
    r.loop();	
	
}

///////////////////////////////////

void bandaUsada(char b)
{
  delay(500);
     switch(b)
        {
          case 0: //FM
            chipRadio.setTuneFrequencyAntennaCapacitor(0);
            chipRadio.setFM(FRECUINI, FRECUFIN, FRECUSTART, Mpasos);
            frecuencia=FRECUSTART;
          break;
          case 1: //AM
              chipRadio.setTuneFrequencyAntennaCapacitor(0);
              chipRadio.setAM(520, 1720, FRECUSTART_AM, Mpasos);
              chipRadio.setBandwidth(bwIdxAM, 1);
              frecuencia=FRECUSTART_AM;
          break;
        }
    
   delay(500);
   chipRadio.setFrequency(frecuencia);
}

void printData(void)
{
  ModeFont=0;
  chipRadio.getCurrentReceivedSignalQuality();
  Mstereo=chipRadio.getCurrentPilot();
  Msnr=chipRadio.getCurrentSNR();
  Mrssi=chipRadio.getCurrentRSSI();
#define YDATA 6

  if(Mmodo==1)
    { sprintf(cadena,"SNR:%02u ",Mrssi);  }
    else
    { sprintf(cadena,"SNR:%02u SIG:%02u %s",Mrssi,Msnr,stereo[Mstereo]);  }    
  xStringAT(0,YDATA,cadena);
}

void printDataS(void)
{
  #define YDATA2 7
  ModeFont=0;
  if(Mmodo==1)
    { sprintf(cadena,"VOL=%02i %s BWam:%s ",Mvolumen,MModeDesc[Mmodo],bandwidthAM[Mwbanda]);  }
    else
    { sprintf(cadena,"VOL=%02i %s  ",Mvolumen,MModeDesc[Mmodo]);  }  
  xStringAT(0,YDATA2,cadena);
}


void printFrecuOLED(void)
{
  ModeFont=2;
  if(Mmodo==0)
      sprintf(cadena,"%03d.%02d MHz ",frecuencia/100,frecuencia%100);  
     else
      sprintf(cadena,"%03d KHz ",frecuencia);
  xStringAT(0,0,cadena);
  Serial.println(cadena);
}

//////////////////////////////////////////////////////////////////////

void menuX()
{
  char e=0;
  modoMenu=1;
  printMenuX(e);
  while(1)
     {
         r.loop();
         delayMicroseconds(100);
        
         if(rDir!=0)
          {
            xStringAT(0,e," ");
            e+=rDir;
            if(e<1) e=0;
            if(e>=NMENUS) e=NMENUS-1;
            xStringAT(0,e,">");
            rDir=0;
          }
        if(1==F_boton())
          {
            if(e==0) {printEstados(); xclearDisplay(); modoMenu=0; return; }
            proceMenuX(e);
            printMenuX(e); 
          }
     }
}


void printEstados(void)
{
    for(char z=0;z<NMENUS;z++)
        {
          Serial.print(menus[z]); Serial.print(" ");
          switch(z)
            {
              case 1:
                Serial.println(Mvolumen,DEC);
              break;
              case 2:
                Serial.println(Mmodo,DEC);
              break;
              case 3:
                Serial.println(Mpasos,DEC);
              break;
              case 4:
                Serial.println(Magc,DEC);
              break;
              case 5:
                Serial.println(Mwbanda,DEC);
              break;
              default:
                Serial.println(" ");
              break;
            }
        }
}


void printMenuX(char op)
{
  xclearDisplay();
  ModeFont=0;
  for(char z=0;z<NMENUS;z++)
    {
      sprintf(cadena,"%s",menus[z]);  xStringAT(2,z,(char *)cadena);
      switch(z)
        {
          case 1:
            sprintf(cadena,"%02i",Mvolumen);
          break;
          case 2:
            sprintf(cadena,"%s",MModeDesc[Mmodo]);
          break;
          case 3:
            sprintf(cadena,"%02i",Mpasos);
          break;
          case 4:
            sprintf(cadena,"%s ",OffOn[!Magc]);
          break;
          case 5:
            sprintf(cadena,"%s",bandwidthAM[bwIdxAM]);
          break;
          case 6:
            sprintf(cadena,"%s ",OffOn[info]);
          break;
          default:
            sprintf(cadena," ");
          break;
        }
       xStringAT(10,z,(char *)cadena);
    }
    xStringAT(0,op,">");
}

char proceMenuX(char op)
{
  xclearDisplay();
  ModeFont=2;
  sprintf(cadena,"%s",menus[op]);  xStringAT(0,1,(char *)cadena);
    
  rDir=0; f2=1;
  switch(op)
    {
      case 1:
        proVolumen();
        chipRadio.setVolume(Mvolumen); 
      break;
      case 2:
        Mmodo=!Mmodo;
        bandaUsada(Mmodo);       
      break;
      case 3:
        proPasos();
      break;
      case 4:
        Magc = !Magc;          //0=Enable   
        chipRadio.setAutomaticGainControl(Magc, 1);     
      break;
      case 5:
        proBwAM();
      break;
      case 6:
        info=!info;
      break;      
    }
  xclearDisplay();
}


void proBwAM()
{
  bwIdxAM++;
  if (bwIdxAM > 6)  bwIdxAM = 0;
  chipRadio.setBandwidth(bwIdxAM, 1);
}


void proPasos()
{
  while(1)
    {
      switch(menuValor2(Mpasos,5,100))
        {
          case 1: //Salir
            return;  
            break;
          case 2:
            sprintf(cadena,"%i ",Mpasos); 
            xStringAT(0,4,(char *)cadena);
            break;       
        }         
    }
}


char menuValor2(char &var,char min,char max)
{
        r.loop();        
        delayMicroseconds(100);
        t++;    
        if(rDir!=0)
          {
            var+=rDir;
            if(var<min) var=min;
            if(var>max) var=max;
            rDir=0; f2=1; t=0;
          }         
        if(1==F_boton()) {return(1); }
        if(t>1000)
            {
              if(f2==1) {  f2=0;  return(2);  }
              t=0;
            }     
        return(0);  
}

void proVolumen()
{ 
  while(1)
  {
    switch(menuValor2(Mvolumen,1,63))
      {
        case 1: //Salir
          return;  
          break;
        case 2:
          sprintf(cadena,"%i  ",Mvolumen);  
          xStringAT(0,4,(char *)cadena); 
          break;       
      }         
  }
}


char F_boton(void)
{
  if (digitalRead(BUTTON_PIN) == 0) 
        {     
          delay(100);
          while(digitalRead(BUTTON_PIN) == 0) ;
          delay(100);
          Serial.println("Boton");
          return(1);
        }
  return(0);
} 


void checkRds() 
{
 int z,t;
 char c;
 char *stationName;
 char miSDR[15];
  chipRadio.rdsBeginQuery();
  stationName = chipRadio.getRdsStationName();
  z=chipRadio.getNumRdsFifoUsed();
  ModeFont=0; 
  if ( stationName != NULL ) 
  {   
    if(z>2)
      {
        Serial.print(">>");
        for(t=0;t<z && t<12;t++)
        {
          c=*(stationName+t);
          if(c==0 || (c>31 && c<126))  {miSDR[t]=c;}        
          xCaracterAT(t,3, c); 
          Serial.print(c);
        }   
      }
  }
}


///////////////////////////////////

void showDirection(Rotary& r) 
{
  if(r.getDirection()==1) rDir=-1; else rDir=1;
              
  if(modoMenu==0)
      {  
          if(Mmodo==0)
          {
            rNum+=rDir;
            frecuencia+=(rDir*Mpasos);
            if(frecuencia<FRECUINI) { frecuencia=FRECUINI; rNum-=rDir; }
            if(frecuencia>FRECUFIN) { frecuencia=FRECUFIN; rNum-=rDir; }
            f3=1;
            Serial.println(frecuencia);
          }
          else
          {
            if(rDir==1)    chipRadio.frequencyUp();
            if(rDir==-1)   chipRadio.frequencyDown(); 
            frecuencia= chipRadio.getFrequency();
            f3=1;        
          }
      }
   t=0;
}
//=================scanI2C=============
void scanI2C() 
{
 int nDevices = 0;

  Serial.println(F("Scanning..."));
  for (byte address = 1; address < 127; ++address) 
  {
    Wire.beginTransmission(address);
    byte error = Wire.endTransmission();

    if (error == 0) 
      {
            Serial.print(nDevices);
            Serial.print(F("-I2C device found at address 0x"));
            if (address < 16) {   Serial.print("0");  }
            Serial.print(address, HEX); 
            switch(address)
            {
              case 0x11:
                Serial.println(F(" SI473X / SI474X"));
              break;
              case 0x38:
                Serial.println(F(" AHTxx"));
              break;
              case 0x3C:
                Serial.println(F(" OLED"));
              break;
              case 0x50:
                Serial.println(F(" AT24C32"));
              break;
               case 0x68:
                Serial.println(F(" DS1371"));
              break;
               case 0x77:
                Serial.println(F(" BMP280"));
              break;
              default:
              Serial.println(F(" ¿Desconocido?"));
              break;
            }
      
            ++nDevices;
          } 
          else 
            if (error == 4) 
            {
            Serial.print(F("Unknown error at address 0x"));
            if (address < 16) {  Serial.print("0"); }
            Serial.println(address, HEX);
            }
    }
    if (nDevices == 0) 
        {  Serial.println(F("No I2C devices found\n")); } 
      else 
        {  Serial.println(F("done\n"));  }
}
